package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.sql.SQLException;
import java.sql.Savepoint;

/**
 * @author Yichen Dai
 * @date 2022/9/9 16:39
 */
@BindClass
public class AgentSavepoint implements Savepoint, Parametrical{

    Savepoint savepoint;

    public AgentSavepoint(Savepoint savepoint){
        this.savepoint = savepoint;
    }

    @Override
    public int getSavepointId() throws SQLException {
        return savepoint.getSavepointId();
    }

    @Override
    public String getSavepointName() throws SQLException {
        return savepoint.getSavepointName();
    }

    @Override
    public Object getHandler() {
        return this.savepoint;
    }
}
