package com.fanruan.agent.jdbc;

import com.fanruan.annotation.BindClass;

import java.sql.SQLException;
import java.sql.Struct;
import java.util.Map;

/**
 * @author Yichen Dai
 * @date 2022/8/31 17:04
 */
@BindClass
public class AgentStruct implements Struct {
    Struct struct;

    public AgentStruct(Struct struct){
        this.struct = struct;
    }

    @Override
    public String getSQLTypeName() throws SQLException {
        return struct.getSQLTypeName();
    }

    @Override
    public Object[] getAttributes() throws SQLException {
        return struct.getAttributes();
    }

    @Override
    public Object[] getAttributes(Map<String, Class<?>> map) throws SQLException {
        return struct.getAttributes(map);
    }
}
