package com.fanruan.annotation;

import java.lang.annotation.*;

/**
 * Mark local methods not to be called remotely
 * @author Yichen Dai
 * @date 2022/8/31 18:34
 */
@Inherited
@Target({ElementType.METHOD})
@Retention(RetentionPolicy.RUNTIME)
public @interface LocalMethod {
}
