package com.fanruan.service.jdbc;

import com.fanruan.annotation.RemoteClass;
import com.fanruan.proxy.ProxyFactory;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.sql.Clob;
import java.sql.NClob;
import java.sql.SQLException;

/**
 * @author Yichen Dai
 * @date 2022/9/9 10:45
 */
@RemoteClass(remoteClassName = "com.fanruan.agent.jdbc.AgentNClob")
public class ServiceNClob extends BasedBind implements NClob {

    @Override
    public long length() throws SQLException {
        return 0;
    }

    @Override
    public String getSubString(long pos, int length) throws SQLException {
        return null;
    }

    @Override
    public Reader getCharacterStream() throws SQLException {
        return (Reader) ProxyFactory.getProxy(ServiceReader.class, info);
    }

    @Override
    public InputStream getAsciiStream() throws SQLException {
        return (InputStream) ProxyFactory.getProxy(ServiceInputStream.class, info);
    }

    @Override
    public long position(String searchstr, long start) throws SQLException {
        return 0;
    }

    @Override
    public long position(Clob searchstr, long start) throws SQLException {
        return 0;
    }

    @Override
    public int setString(long pos, String str) throws SQLException {
        return 0;
    }

    @Override
    public int setString(long pos, String str, int offset, int len) throws SQLException {
        return 0;
    }

    @Override
    public OutputStream setAsciiStream(long pos) throws SQLException {
        return (OutputStream) ProxyFactory.getProxy(ServiceOutputStream.class, info);
    }

    @Override
    public Writer setCharacterStream(long pos) throws SQLException {
        return (Writer) ProxyFactory.getProxy(ServiceWriter.class, info);
    }

    @Override
    public void truncate(long len) throws SQLException {

    }

    @Override
    public void free() throws SQLException {

    }

    @Override
    public Reader getCharacterStream(long pos, long length) throws SQLException {
        return (Reader) ProxyFactory.getProxy(ServiceReader.class, info);
    }
}
