package com.fanruan.service.jdbc;

import com.fanruan.annotation.LocalMethod;
import com.fanruan.annotation.NotImplemented;
import com.fanruan.annotation.RemoteClass;

import java.sql.ParameterMetaData;
import java.sql.SQLException;

/**
 * @author Yichen Dai
 * @date 2022/8/25 11:13
 */
@RemoteClass(remoteClassName = "com.fanruan.agent.jdbc.AgentParameterMetaData")
public class ServiceParameterMetaData extends BasedBind implements ParameterMetaData {

    @Override
    public int getParameterCount() throws SQLException {
        return 0;
    }

    @Override
    public int isNullable(int param) throws SQLException {
        return 0;
    }

    @Override
    public boolean isSigned(int param) throws SQLException {
        return false;
    }

    @Override
    public int getPrecision(int param) throws SQLException {
        return 0;
    }

    @Override
    public int getScale(int param) throws SQLException {
        return 0;
    }

    @Override
    public int getParameterType(int param) throws SQLException {
        return 0;
    }

    @Override
    public String getParameterTypeName(int param) throws SQLException {
        return null;
    }

    @Override
    public String getParameterClassName(int param) throws SQLException {
        return null;
    }

    @Override
    public int getParameterMode(int param) throws SQLException {
        return 0;
    }

    @Override
    @LocalMethod
    @NotImplemented
    public <T> T unwrap(Class<T> iface) throws SQLException {
        throw new SQLException("Not Implement!");
    }

    @Override
    public boolean isWrapperFor(Class<?> iface) throws SQLException {
        return false;
    }
}
