package com.fanruan;

import com.fanruan.pojo.message.RpcRequest;
import com.fanruan.proxy.interceptor.Interceptor;
import net.sf.cglib.proxy.Enhancer;

import java.util.Map;
import java.util.Properties;

/**
 * @author Yichen Dai
 * @date 2022/8/29 11:15
 */
public class ProxyFactoryIT {

    public static Object getProxy(Class<?> clazz, Map<String, RpcRequest> map){
        final Enhancer enhancer = new Enhancer();
        enhancer.setClassLoader(clazz.getClassLoader());
        enhancer.setSuperclass(clazz);
        enhancer.setCallback(new InterceptorIT(clazz, map));
        return enhancer.create();
    }
}
